<?php
defined('BASEPATH') OR exit('No direct script access allowed');

//$route['view-member'] = 'auth/get_by_userType/'.USER;
//$route['view-editor'] = 'auth/get_by_userType/'.EDITOR;


/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/

$route['default_controller'] = 'home/index';

$route['\w{2}/admin'] = 'auth/login';


$route['\w{2}/logmeout'] = 'auth/userlogout';
$route['\w{2}/myorder'] = 'home/userorder';
$route['\w{2}/profile'] = 'home/profile';
$route['\w{2}/checForMin'] = 'cart/checForMin';
$route['\w{2}/confirm'] = 'cart/confirm';
$route['\w{2}/get-detail'] = 'user/getdetail';
$route['\w{2}/join'] = 'page/join';

$route['\w{2}/checkout'] = 'cart/checkout';
$route['\w{2}/finish'] = 'cart/finish';
$route['\w{2}/payment_success'] = 'stripe/success';

//$route['services'] = 'page/services';
/******cms pages*******/
$route['\w{2}/privacy-policy'] = 'page/cms/2';
$route['\w{2}/terms'] = 'page/cms/3';
$route['\w{2}/about-us'] = 'page/cms/4';

$route['\w{2}/faq'] = 'page/faq';


//$route['contact'] = 'page/contact';
$route['\w{2}/login'] = 'page/login';


$route['\w{2}/bed'] = 'hajjpackages/bed_manage';
$route['\w{2}/currencymethod'] = 'hajjpackages/currencymethod';
$route['\w{2}/tentmethod'] = 'hajjpackages/tentmethod';
$route['\w{2}/setpackagecart'] = 'hajjpackages/setpackagecart';
$route['\w{2}/removepackagecart'] = 'hajjpackages/removepackagecart';
$route['\w{2}/hajjpackages/detail-(:num)'] = '/hajjpackages/detail/$1';
// $route['hajjpackages/booking-(:num)'] = '/hajjpackages/booking/$1';
$route['\w{2}/hajjpackages/booking'] = '/hajjpackages/booking';

$route['\w{2}/view_users'] = 'auth/view_users';
$route['\w{2}/add-user'] = 'auth/create_user';

$route['\w{2}/add-rout/(:num)'] = 'bus/rout/saveData/$1';

$route['\w{2}/freelancers/(:num)'] = 'freelancers/filterbycategory/$1';
$route['\w{2}/freelancers/(:any)'] = 'freelancers/profile/$1';
$route['\w{2}/freelancers/(:any)/(:any)'] = 'freelancers/servicedetail/$1/$2';

$route['\w{2}/seller/editservice(:num)'] = 'seller/editservice/$1';
$route['\w{2}/news/(:any)'] = 'news/detail/$1';

//$route['default_controller'] = 'home/index';
$route['404_override'] = '';
$route['translate_uri_dashes'] = FALSE;

require_once( BASEPATH .'database/DB'. EXT );
$db =& DB();
$query = $db->get( 'app_routes' );
$result = $query->result();
foreach( $result as $row )
{
    $route[ $row->slug ]                 = $row->controller;
    $route[ $row->slug.'/:any' ]         = $row->controller;
    $route[ $row->controller ]           = 'error404';
    $route[ $row->controller.'/:any' ]   = 'error404';
}

$route['(\w{2})/(.*)'] 							= '$2';
$route['(\w{2})'] 								= $route['default_controller'];


