<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Api extends CI_Controller {
public $tbl_user ="users";



    function __construct()
	{
		parent::__construct();
                $this->load->model('Api_model','AM');
	}
        
    public function index()
	{
            echo 'here';
	}
	
	
	
	
	
	
	
    ////////////////////////////// USER APIS START///////////////////////////////////    
    function verifyRequiredParams($required_fields) {
            $error = false;
            $error_fields = "";
            $request_params = array();
            $request_params = $_POST;
            // Handling PUT request params
            foreach ($required_fields as $field) {
                if (!isset($request_params[$field]) || strlen(trim($request_params[$field])) <= 0) {
                    $error = true;
                    $error_fields .= $field . ', ';
                }
            }
            if ($error) {
                // Required field(s) are missing or empty
                // echo error json and stop the app
                $response = array();
                $response["status"] = 204;
                $response["message"] = 'Required field(s) ' . substr($error_fields, 0, -2) . ' is missing or empty';
                echo json_encode($response);
                return false;
            } else {
                return true;
            }
    }
        
    /****************** SIGNUP OR REGISTER **************************/
    public function signup() {
		extract($_POST);
		$response=array();
                
                //Validating Required Params
                if($this->verifyRequiredParams(array("name","email","password","birthday","country","timezone","device_type","device_id"))){
                    //Checking Email already exists
                    $emailExist = $this->AM->mail_exists($email);
                    if($emailExist){
                        $response['status']=204;
                        $response['message']="Email exist already";
                        echo json_encode($response);
                        exit;
                    }
		
                    //$_POST["password"] = md5($_POST["password"]);

                   $id=$this->AM->insert($this->tbl_user, $_POST); 
                   if($id>0){	
                        $user = $this->AM->getUserById($id);
                        //removing password from response
                        unset($user['password']);
                        if ($user != NULL) {
                            $response["status"] = 200;
                            $response['message'] = "Successfully Signup";
                            $response['user'] = $user;
                            echo json_encode($response);
                            exit;
                        }
                    }
                }//validation of required fields
                exit;
    }

    public function login() {
		extract($_POST);
		$response=array();
                
                //Validating Required Params
                if($this->verifyRequiredParams(array("email","password","device_type","device_id"))){
                    
                     // check for correct email and password
                    if ($user_id=$this->AM->checkLogin($email, $password)) {
                        
                        //update device_type and device_id
                        $userUpdateDevices = $this->AM->updateDevice($user_id,$device_type,$device_id);
                       
                        
                        // get the user by email
                        $user = $this->AM->getUserById($user_id);
                        //removing password from response
                        unset($user['password']);
                        
                        
                        if ($user != NULL) {
                            $response["status"] = 200;
                            $response['message'] = "Successfully Login";
                            $response['user'] = $user;
                            echo json_encode($response);
                            exit;
                        }
                    } else {
                        // user credentials are wrong
                        $response['status'] = 204;
                        $response['message'] = 'Login failed. Incorrect credentials';
                        echo json_encode($response);
                        exit;
                    }

                }//validation of required fields
                exit;
    }
    public function profile(){
        extract($_POST);
		$response=array();
                
                //Validating Required Params
                if($this->verifyRequiredParams(array("user_id"))){
                    
                        // get the user by id
                        $user = $this->AM->getUserById($user_id);
                        //removing password from response
                                               
                        if ($user != NULL) {
                            unset($user['password']);
                            $response["status"] = 200;
                            $response['message'] = "User Profile";
                            $response['user'] = $user;
                            $response['user']['stats']=$this->AM->getUsersStatsByUserId($user_id);
                            echo json_encode($response);
                            exit;
                        } else {
                        // user credentials are wrong
                        $response['status'] = 204;
                        $response['message'] = 'User does not exists';
                        echo json_encode($response);
                        exit;
                    }
                }
    }
////////////////////////////// USER APIS END///////////////////////////////////    
        
    
    
////////////////////////////// PRE DEFINED APIS START//////////////////////////
        public function predefined(){
                $sentences = $this->AM->getPredefined();
                $response["status"] = 200;
                $response['message'] = "Predefined Answers.";
                $response['predefined_answers'] = $sentences;
                echo json_encode($response);
                exit;
        }
////////////////////////////// PRE DEFINED APIS END////////////////////////////  

////////////////////////////// PRE DEFINED APIS START//////////////////////////
        public function topics(){
                $topics = $this->AM->getTopics();
                $response["status"] = 200;
                $response['message'] = "All Topics.";
                $response['topics'] = $topics;
                echo json_encode($response);
                exit;
        }
        public function api(){
                $categories = $this->AM->getCategories();
                $response["status"] = 200;
                $response['message'] = "All Categories";
                $response['categories'] = $categories;
                echo json_encode($response);
                exit;
        }  
        
        public function product(){
                extract($_POST);
                $products = $this->AM->getProducts($cat_id);
                $response["status"] = 200;
                $response['message'] = "All Products";
                $response['products'] = $products;
                echo json_encode($response);
                exit;
        }

////////////////////////////// PRE DEFINED APIS END//////////////////////////// 
        
////////////////////////////// Rating APIS START//////////////////////////
        public function ratetopic(){
            extract($_POST);
		$response=array();
                
                //Validating Required Params
                if($this->verifyRequiredParams(array("user_id","topic_id","rating"))){
                    
                     // check for correct email and password
                    if ($rating_id=$this->AM->ratingStatus($_POST)) {
                        if ($rating_id != NULL) {
                            $response["status"] = 200;
                            $response['message'] = "Successfully Rating Saved.";
                            $response['rating'] = $rating;
                            echo json_encode($response);
                            exit;
                        }
                    } else {
                        // user credentials are wrong
                        $response['status'] = 204;
                        $response['message'] = 'Filed to Put Ratings';
                        echo json_encode($response);
                        exit;
                    }

                }//validation of required fields
                exit;
        }
////////////////////////////// Rating APIS END////////////////////////////         
//////////////////////////// Answer APIS START//////////////////////////
        public function answer(){
            extract($_POST);
	    $response=array();
                
                //Validating Required Params
                if($this->verifyRequiredParams(array("user_id","topic_id","answer"))){
                    
                    if ($rating_id=$this->AM->addAnswer($_POST)) {
                        if ($rating_id != NULL) {
                            $response["status"] = 200;
                            $response['message'] = "Successfully Saved.";
                            echo json_encode($response);
                            exit;
                        }
                    } else {
                        // user credentials are wrong
                        $response['status'] = 204;
                        $response['message'] = 'Filed to Save Answer.';
                        echo json_encode($response);
                        exit;
                    }

                }//validation of required fields
                exit;
        }
        function forgotPassword() {
        if ($this->verifyRequiredParams(array("email"))) {
            extract($_POST);
            $result = $this->db->select('id')->from($this->tbl_user)->where(array("email" => $email))->get();
            if ($result->num_rows() == 1) {
                $response['status'] = 200;
                $response['message'] = "New login details has been sent on your email.";
                $password = rand(1000000, 9999999);
                $this->sendPassordResetEmail($email, $password);
                $row = $result->row();
                //update password 
                $this->db->where("id", $row->id);
                $this->db->update($this->tbl_user, array("password" => md5($password)));
                echo json_encode($response);
                exit;
            } else {
                $this->print_error("Invalid Email");
            }
        }
    }

    function sendPassordResetEmail($email, $password) {
        $to = $email;
        $subject = "Infosnack New login deatils";
        $message = "Your Infosnack new login password is: " . $password;
        mail($to, $subject, $message);
    }

        
        
        public function myanswer(){
            extract($_POST);
	    $response=array();
                
                //Validating Required Params
                if($this->verifyRequiredParams(array("user_id","topic_id"))){
                    
                     // check for correct email and password
                    if ($answer=$this->AM->answerStatus($_POST)) {
                        if (count($answer) > 0) {
                            $response["status"] = 200;
                            $response['message'] = "Already Answered";
                            $response['answer'] = $answer[0];
                            echo json_encode($response);
                            exit;
                        }
                    } else {
                        // user credentials are wrong
                        $response['status'] = 204;
                        $response['message'] = 'Please give your answer first to learn more.';
                        echo json_encode($response);
                        exit;
                    }

                }//validation of required fields
                exit;
        }
////////////////////////////// Rating APIS END////////////////////////////         

//////////////////////////// Like/Unlike APIS START//////////////////////////
        public function likeunlike(){
            extract($_POST);
	    $response=array();
                
                //Validating Required Params
                if($this->verifyRequiredParams(array("user_id","answer_id","islike"))){
                    
                     // check for correct email and password
                    if ($rating_id=$this->AM->likesdislikesStatus($_POST)) {
                        if ($rating_id != NULL) {
                            $response["status"] = 200;
                            $response['message'] = "Successfully Saved.";
                            echo json_encode($response);
                            exit;
                        }
                    } else {
                        // user credentials are wrong
                        $response['status'] = 204;
                        $response['message'] = 'Filed to update';
                        echo json_encode($response);
                        exit;
                    }

                }//validation of required fields
                exit;
        }
////////////////////////////// Like/Unlike APIS END////////////////////////////  
        public function getanswers(){
            extract($_POST);
	    $response=array();
                
            //if user_id is sent than return user answers from all topics
            $validation = "topic_id";
            if(isset($_POST["user_id"]) && $_POST["user_id"] != ""){
                $validation = "user_id";
            }
            
                //Validating Required Params
                if($this->verifyRequiredParams(array($validation))){
                    
                     // check for correct email and password
                    if ($answers=$this->AM->topicAnswersOrUserAnswers($_POST)) {
                        
                            for ( $i=0; $i< count($answers); $i++) {
                                 $answers[$i]["likes"]= $this->AM->totalLikesOrUnlikes($answers[$i]["id"],1);
                                 $answers[$i]["unlikes"]= $this->AM->totalLikesOrUnlikes($answers[$i]["id"],0);
                            }
                            $response["status"] = 200;
                            $response['message'] = "all Answers.";
                            $response['answers'] = $answers;
                            echo json_encode($response);
                            exit;
                    } else {
                        // user credentials are wrong
                        $response['status'] = 204;
                        $response['message'] = 'This topic donot have answers.';
                        echo json_encode($response);
                        exit;
                    }

                }//validation of required fields
                exit;
        }
        
    function print_error($message) {
        $response['status'] = 204;
        $response['message'] = $message;
        echo json_encode($response);
        exit;
    }
      function updateProfilePicture() {
        if ($this->verifyRequiredParams(array("user_id"))) {

            if (isset($_FILES['image']['name'])) {
                $info = pathinfo($_FILES['image']['name']);
                $ext = $info['extension']; // get the extension of the file
                $newname = rand(5, 3456) * date(time()) . "." . $ext;
                $target = 'uploads/' . $newname;
                if (move_uploaded_file($_FILES['image']['tmp_name'], $target)) {
                    $image = 'uploads/'.$newname;
                }
            } else {
                $this->print_error("image is required!");
            }
            extract($_POST);
            $this->db->where('id', $user_id);
            $this->db->update($this->tbl_user, array('image' => $image));
            if ($this->db->affected_rows() == true) {

                $result = $this->db->select('image')->from($this->tbl_user)->where(array("id" => $user_id))->get();
                if ($result->num_rows() == 1) {
                    $row = $result->row();
                    $row->image = $row->image;
                    $response['status'] = 200;
                    $response['message'] = 'Profile Picture Successfully Updated!';
                    $response['object'] = $row;
                }
                echo json_encode($response);
                exit;
            } else {
                $response["status"] = 204;
                $response['message'] = 'No New values(changes) to update!';
                echo json_encode($response);
                exit;
            }
        }
    }   
      function updateProfileCover() {
        if ($this->verifyRequiredParams(array("user_id"))) {

            if (isset($_FILES['image']['name'])) {
                $info = pathinfo($_FILES['image']['name']);
                $ext = $info['extension']; // get the extension of the file
                $newname = rand(5, 3456) * date(time()) . "." . $ext;
                $target = 'uploads/' . $newname;
                if (move_uploaded_file($_FILES['image']['tmp_name'], $target)) {
                    $image = 'uploads/'.$newname;
                }
            } else {
                $this->print_error("image is required!");
            }
            extract($_POST);
            $this->db->where('id', $user_id);
            $this->db->update($this->tbl_user, array('cover' => $image));
            if ($this->db->affected_rows() == true) {

                $result = $this->db->select('cover')->from($this->tbl_user)->where(array("id" => $user_id))->get();
                if ($result->num_rows() == 1) {
                    $row = $result->row();
                    $row->cover = $row->cover;
                    $response['status'] = 200;
                    $response['message'] = 'Profile Cover Successfully Updated!';
                    $response['object'] = $row;
                }
                echo json_encode($response);
                exit;
            } else {
                $response["status"] = 204;
                $response['message'] = 'No New values(changes) to update!';
                echo json_encode($response);
                exit;
            }
        }
    }   
     public function logout()
        {
            echo 'here';
        }
        
     public function forgotpss()
        {
            echo 'here';
        }
        
}
