
var $app = {
  init: function () {
    $("form#package-filter,  form#mobile-package-filter").change(function () {
      $app.filterPackages($(this));
    });

    $("#package-search").on( 'input focus', function () {
      var search_text = $(this).val();
      if(search_text.length > 2) {
        $app.findPackagesAndProviders(search_text);
      } else {
        $('#topbar_results').css('display', 'none');
      }
      $(window).click(function() {
        if($('#topbar_results').css('display') === 'block')
          $('#topbar_results').css('display', 'none');
      });
      $(this).click(function(event){
        event.stopPropagation();
      });
    });

    $app.mobileNav();
    $app.filterToggle();
    $app.driftClass();
  },
  filterPackages: function (form) {
	 
    var data = form.serialize();
    data = data.replace('min_mprice', 'min_price');
    data = data.replace('max_mprice', 'max_price');
    data = data.replace('min_mduration', 'min_duration');
    data = data.replace('max_mduration', 'max_duration');

    console.log(data);
    var request = $.ajax({
      url: "/packages-data",
      method: "GET",
      data: data,
      dataType: "json",
      beforeSend:function(){ $("#loading").show(); },
      complete:function(){ $("#loading").hide(); }
    });

    request.done(function (response) {
      $app.updatePackagesCount(response['original_count'], Object.keys(response).length - 1);
      delete response['original_count'];
      $app.updatePackagesList(response);
      window.history.pushState({path: './packages?' + data}, '', './packages?' + data);
      return response;
    });

    request.fail(function (jqXHR, textStatus) {
      console.log("Request failed: " + textStatus);
    });
  },
  findPackagesAndProviders: function (search_text) {
    var request = $.ajax({
      url: "/search/" + search_text,
      method: "GET",
      dataType: "json"
    });

    request.done(function (response) {
      console.log(response);
      var html = '';

      if(response['providers'].length > 0) {
        html += '<h3>Providers</h3>';
        html += '<ul>';
        for (var i=0; response['providers'].length > i; i++) {
          html += '<li><a href="/provider/' + response['providers'][i]['id'] + '"><img class="new_provider_logo" src="' + response['providers'][i]['logo'] + '" alt="' + response['providers'][i]['name'] + '">';
          html += response['providers'][i]['name'];
          html += '</a><br>';
          html += '</li>';
        }
        html += '</ul>';
      } else {
        html += '<p>No results matched your search criteria</p>';
      }
      $('#topbar_results').css('display', 'block');
      $('#topbar_results').html(html);
      return response;
    });

    request.fail(function (jqXHR, textStatus) {
      console.log("Request failed: " + textStatus);
    });
  },
  rangeSlider: function (id, min, max, step, prepend, append) {
    var rangeSlider = document.getElementById(id);
    var url = new URL(window.location.href);
    var min_start = 'min_' + (id.charAt(0) === 'm' ? id.split('-')[0].substr(1) : id.split('-')[0]);
    var max_start = 'max_' + (id.charAt(0) === 'm' ? id.split('-')[0].substr(1) : id.split('-')[0]);

    noUiSlider.create(rangeSlider, {
      start: [(url.searchParams.get(min_start) ? url.searchParams.get(min_start) : min), (url.searchParams.get(max_start) ? url.searchParams.get(max_start) : max)],
      step: step,
      connect: true,
      range: {
        'min': [min],
        'max': [max]
      }
    });

    var min_nodes = document.getElementsByClassName('min-' + id);
    var max_nodes = document.getElementsByClassName('max-' + id);

    // Display the slider value
    rangeSlider.noUiSlider.on('update', function (values) {
		
		for (var i = 0; i < min_nodes.length; i++) {
				var min_value = Math.round(values[0]);
				var max_value = Math.round(values[1]);
		
				min_nodes[i].innerHTML = prepend + min_value + append;
				min_nodes[i].value = min_value;
		
				max_nodes[i].innerHTML = prepend + max_value + append;
				max_nodes[i].value = max_value;
		  }
    });
  },
  updatePackagesList: function (packages) {
    console.log(packages);

    var ul = $('.results_list > ul');
    ul.html('');
    for (var i = 0; i < Object.keys(packages).length; i++) {
      var li = $app.packageHtml(packages[i]);
      ul.append(li);
    }

  },
  packageHtml: function (hajj_package) {

    var html = '<li class="new_result">';
    html += '<div class="result_header"><div class="provider_logo"><img class="new_provider_logo" src="../storage/' + hajj_package['provider_logo'] + '" alt="' + hajj_package['provider_name'] + '"></div>';
    html += '<div class="title_block"><a href="/package/' + hajj_package['package_id'] + '">';
    html += '<h2>' +  hajj_package['package_name'] + '</h2></a><span class="shifting_status">' + (hajj_package['is_shifting'] ? 'Shifting' : 'Non-shifting') + '</span>';
    html += '<div class="trip_dates">' + hajj_package['date_string'] + '</div>';
    html += '</div>';
    html += '</div>';
    html += '<hr>';
    html += '<div class="hotels">';
    for (var i = 0; i < hajj_package['accommodations'].length; i++) {
      if(hajj_package['accommodations'][i]['city_name'] === 'Makkah' || hajj_package['accommodations'][i]['city_name'] === 'Madinah')  {
        html += '<div class="accommodation_block">';
        html += '<h3 class="' + hajj_package['accommodations'][i]['city_name'].toLowerCase() + '">' + hajj_package['accommodations'][i]['city_name'] + '</h3><img class="hotel_preview" src="../storage/' + hajj_package['accommodations'][i]['image'] + '" alt="' + hajj_package['accommodations'][i]['name'] + '">';
        html += '<div class="hotel_excerpt">';
        html += '<h4>' + hajj_package['accommodations'][i]['name'] + '</h4>';
        html += '<ul>';
        html += '<li class="stars">' + '&#9733 '.repeat(hajj_package['accommodations'][i]['rating']) + '</li>';
        html += '<li class="sub_info walk"><img src="../images/walk_icon.svg" alt="Walking Distance Icon">';
        html += '<p>' + hajj_package['accommodations'][i]['walking_distance'] + '-min walk<br>from ' + hajj_package['accommodations'][i]['city_place'] + '</p>';
        html += '</li>';
        html += '</ul>';
        html += '</div>';
        html += '</div>';
      }
    }
    html += '</div>';
    html += '<div class="price_footer">';
    html += '<div class="price"><sup class="pound">£</sup><span class="pricetext">' + hajj_package['min_price'] + '</span>';
    html += '<p>Starting from per person</p>';
    html += '</div>';
    html += '<div class="cta"><a class="button" href="/package/' + hajj_package['package_id'] + '">See full package details</a></div>';
    html += '</div>';
    html += '</li>';

    return html;
  },
  updatePackagesCount: function(original_count,count){
    console.log(original_count);
    if(original_count > 0) {
      $('.current_packages').html('<p>Currently showing <span>' + count + ' Hajj packages</span></p>');
      $('.filter_bar > span > b').html(count + ' results');
    } else {
      $('.current_packages').html('<div class="alert alert-info"><strong>Oops..</strong> could not find any packages matching your search criteria. You might be interested in these. </div>');
      $('.filter_bar > span > b').html(count + ' results');
    }
  },
  mobileNav : function() {
    $('.nav-toggle').on('click', function () {
      $('nav#mobile, body').toggleClass('open');
    });

    $('.subnav-toggle').on('click', function () {
      $(this).next().toggleClass('open');
      $(this).toggleClass('fa-chevron-down fa-chevron-up');
    });
  },
  filterToggle : function() {
    $('.filter-toggle').on('click', function () {
      $('nav#filters, body').toggleClass('open');
    });
  },
  filterOptions : function() {
    $('#package-filter > [class$=_options]').on('click', function(){

      var e = $('.' + $(this)[0].className.split('_')[0] + '_filter');
      if(!e.is(':hover')){
        $(this).find('.caret-down').css('transform', 'rotate(0)');

        if(e.css('display') === 'block') {
          e.css('display', 'none');
        } else {
          $('#package-filter [class$=_filter]').hide();
          $('.caret-down').css('transform', 'rotate(0)');
          e.css('display', 'block');
          $(this).find('.caret-down').css('transform', 'rotate(180deg)');
        }
      }

      $(window).click(function() {
        if(e.css('display') === 'block'){
          e.css('display', 'none');
          $('.caret-down').css('transform', 'rotate(0)');
        }
      });
      $('.filter_bar_content ').click(function(event){
        event.stopPropagation();
      });
    });
  }
  
};

$(document).ready(function () {
  $app.init();
});

